import java.util.*;

public class PersonStudentInterfaceTest {

	public static void print(Object[] array) {
		for(Object o : array) {
			System.out.println(o);
		}		
	}
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		Student[] sList = new Student[3];
		sList[0] = new Student("Kevin", 0, 222);
		sList[1] = new Student("Jason", 1, 333);
		sList[2] = new Student("John", 2, 111);

		System.out.println("STUDENT SORT BY NAME (DEFAULT)!!!");
		Arrays.sort(sList); // Comparable<Person> interface 사용
		print(sList);
		
		System.out.println("STUDENT SORT by AGE!!!");
		Arrays.sort(sList, Student.AgeComparator);
		print(sList);

		System.out.println("STUDENT SORT by ID!!!");
		Arrays.sort(sList, Student.IDComparator);
		print(sList);
		
		//////////////////////////////////////
		System.out.println("//////////////////");
		Student[] sList2 = new Student[3];
		sList2[0] = new Student("Kevin", 0, 222);
		sList2[1] = new Student("Jason", 1, 333);
		sList2[2] = new Student("John", 2, 111);

		System.out.println("STUDENT SORT BY NAME (anonymous method)!!!");
		Arrays.sort(sList2, new Comparator<Student>() {
		            public int compare(Student s1, Student s2) {
		                return s1.getName().toUpperCase().compareTo(s2.getName().toUpperCase());
		            }
		        });
		print(sList2);

		System.out.println("STUDENT SORT by AGE (anonymous method)!!!");
		Arrays.sort(sList2, new Comparator<Student>() {
		            public int compare(Student s1, Student s2) {
		                return s1.getAge() - s2.getAge();
		            }
		        });
		print(sList2);

		System.out.println("STUDENT SORT by ID (anonymous method)!!!");
		Arrays.sort(sList2, new Comparator<Student>() {
		            public int compare(Student s1, Student s2) {
		                return s1.getID() - s2.getID();
		            }
		        });
		print(sList2);
		
		System.out.println("//////////////////////////////");
		Student[] sList3 = sList2;

		System.out.println("STUDENT SORT BY NAME (lambda)!!!");
		Arrays.sort(sList3, (Student ss1, Student ss2) ->
		                ss1.getName().compareTo(ss2.getName())
		        );
		Arrays.stream(sList3).forEach((s) -> System.out.println(s));

		System.out.println("STUDENT SORT by AGE (lambda)!!!");
		Arrays.sort(sList3, (Student ss1, Student ss2) ->
		                Integer.compare(ss1.getAge(), ss2.getAge())
		        );
		Arrays.stream(sList3).forEach((s) -> System.out.println(s));

		System.out.println("STUDENT SORT by ID (lambda)!!!");
		Arrays.sort(sList3, (Student ss1, Student ss2) ->
		                Integer.compare(ss1.getID(), ss2.getID())
		        );
		Arrays.stream(sList3).forEach((s) -> System.out.println(s));
	}

}
