import java.util.*;

class Student extends Person 
{
	private static int count = 0;   // static (class) variables
	protected int id;
	
	public Student()
	{
		id = 5208;
	}
	
	public Student(String name, int age, int id)
	{
		super(name, age);
		this.id = id;
		count++;
	}
	
	public int getID()
	{
		return id;
	}
	
	public void setID(int id)
	{
		this.id = id;
	}
	
	@Override
	public boolean equals(Object other)                             // Object.equals overriding
	{
		if (other instanceof Student) {
			Student that = (Student) other;
			return that.canEqual(this) && this.getName().equals(that.getName()) && this.getAge() == that.getAge() && this.getID() == that.getID();
		}
		return false;
	}
	
	@Override
	public int hashCode() {
		return (41 * super.hashCode() + getID());
	}
	
	public boolean canEqual(Object other) {
		return (other instanceof Student);
	}
	
	@Override
	public String toString() // Object.toString() overriding
	{
		return "Student Name: " + name + " Age: " + age + " ID: " + id;
	}
	
	public void superPrint()
	{
		super.print();
	}
	
	public void print() // Person class print() method overriding
	{
		System.out.println("Student Name: " + name + " Age: " + age + " ID: " + id);
	}
	
	public void set(String name, int age, int id)
	{
		super.set(name, age);
		this.id = id;
	}
	
	public void set(String name, int age)
	{
		super.set(name, age);
	}
	
	public void set(Student other)
	{
		this.set(other.name, other.age, other.id);
	}
	
	public void set(Person other)
	{
		if (other instanceof Person)
			super.set(other);
		else
			this.set((Student)other);
	}
	
	public Student clone()
	{
		Student s = new Student(this.name, this.age, this.id);
		return s;
	}
	
	public static void printCount()         // static (class) methods
	{
		System.out.println("Student Count: " + count);
	}
	
	public static int getCount() { return count; }     // static (class) methods
	public static void setCount(int value) { count = value; }       // static (class) methods
	
	public int compareTo(Student other) 
	{
	      String thisName = this.getName().toUpperCase();
	      String otherName = other.getName().toUpperCase();
	
	      //ascending order
	      return thisName.compareTo(otherName);
	      //descending order
	      //return otherName.compareTo(thisName);
	}
	
	public static Comparator<Student> AgeComparator
	                          = new Comparator<Student>() {
	     public int compare(Student p1, Student p2) {
	       int age1 = p1.getAge();
	       int age2 = p2.getAge();
	
	       //ascending order
	       return age1 - age2;
	
	       //descending order
	       //return age2 – age1;
	     }
	};
	
	public static Comparator<Student> IDComparator
	                          = new Comparator<Student>() {
	     public int compare(Student p1, Student p2) {
	       int id1 = p1.getID();
	       int id2 = p2.getID();
	
	       //ascending order
	       return id1 - id2;
	
	       //descending order
	       //return id2 – id1;
	     }
	};
}